package com.tofly.spire.service;


import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.IService;
import com.tofly.spire.entity.SpireMinGrid;
import com.tofly.spire.entity.dto.SpireMinGridDto;

import org.springframework.web.multipart.MultipartFile;

import java.io.Serializable;
import java.util.List;

/**
 * 小表（户表）(SpireMinGrid)表服务接口
 *
 * @author HaiQiu
 * @since 2022-11-11 11:52:49
 */
public interface SpireMinGridService extends IService<SpireMinGrid> {

    /**
     * 根据ID查询
     *
     * @param id id
     * @return 数据
     */
    SpireMinGrid get(Serializable id);

    /**
     * 新增
     *
     * @param spireMinGridDto 实体
     */
    void insert(SpireMinGridDto spireMinGridDto);

    /**
     * 修改
     *
     * @param spireMinGridDto 实体
     */
    void edit(SpireMinGridDto spireMinGridDto);

    /**
     * 批量删除
     *
     * @param idList 数据ID集合
     */
    void delete(List<Long> idList);

    /**
     * 生成模板下载
     */
    void template();

    /**
     * 数据导入
     *
     * @param file 文件
     */
    void importData(MultipartFile file);

    /**
     * 分页查询
     *
     * @param page         分页
     * @param spireMinGrid 查询wrapper
     * @return 数据集合
     */
    Page<SpireMinGrid> pageList(Page page, SpireMinGrid spireMinGrid);

    /**
     * 数据导出
     *
     * @param page         分页
     * @param spireMinGrid 查询模型
     * @param isAll        是否导出全部数据，true是，false否
     */
    void export(Page page, SpireMinGrid spireMinGrid, Boolean isAll);

    /**
     * 查询所有数据
     *
     * @param spireMinGrid 查询条件
     * @return 查询所有数据
     */
    List<SpireMinGrid> allList(SpireMinGrid spireMinGrid);


    long getMeterData(String sn, String date);
}

